#include <stdlib.h>

#include <stdio.h>
#include <string.h>

#include "Client.h"


// outgoing emails leave the client at this point. here they are put in an outgoing queue instead.
void 
mail__wrappee__SingleLinkedList (struct client *client, struct email *msg)
{
  //TODO 
//  printf ("=> %s MAIL\n", client->name);
//  printMail (msg);
  if (!client->outgoingBuffer)
    client->outgoingBuffer = list_create (msg);
  else
    list_insert_after (client->outgoingBuffer, msg);
}



void
mail (struct client *client, struct email *msg)
{
// VERIFICATION HOOK
  int verificationHook_isEncrypted = isEncrypted (msg);
  printf ("mail:\nisEncrypted = %i\nid = %i\n", verificationHook_isEncrypted,
	  msg->id);
// VERIFICATION HOOK END
  mail__wrappee__SingleLinkedList(client, msg);
}


// emails to be sent are processed by this method before beeing mailed.
void 
outgoing__wrappee__SingleLinkedList (struct client *client, struct email *msg)
{
  msg->from = strdup (client->name);
  mail (client, msg);
}


void
outgoing (struct client *client, struct email *msg)
{
  encrypt (client, msg);
  outgoing__wrappee__SingleLinkedList(client, msg);
}


// incoming emails reach the user at this point. here they are put in a mailbox.
void
deliver (struct client *client, struct email *msg)
{
  //TODO
  // printf ("=> %s DELIVER\n", client->name);
  //printMail (msg);
}


// incoming emails are processed by this method before delivery.
void 
incoming__wrappee__SingleLinkedList (struct client *client, struct email *msg)
{
  deliver (client, msg);
}


void 
incoming__wrappee__Encrypt (struct client *client, struct email *msg)
{
  incoming__wrappee__SingleLinkedList(client, msg);
}


void
incoming (struct client *client, struct email *msg)
{
// VERIFICATION HOOK
  int verificationHook_isEncrypted = isEncrypted (msg);
  printf ("incoming:\nisEncrypted = %i\nid = %i\n",
	  verificationHook_isEncrypted, msg->id);
// VERIFICATION HOOK END
  decrypt (client, msg);
  incoming__wrappee__Encrypt(client, msg);
}
void
encrypt (struct client *client, struct email *msg)
{
  NODE *foundPublicKeyPair =
    list_find (client->userPublicKeyPairs, findUserPublicKeyPair, msg->to);
  if (foundPublicKeyPair)
    {
      msg->encryptionKey =
	strdup (((struct userPublicKeyPair *) foundPublicKeyPair->data)->
		publicKey);
      msg->isEncrypted = 1;
    }
}

// removes the decryption flag if possible
void
decrypt (struct client *client, struct email *msg)
{
// VERIFICATION HOOK
  int verificationHook_isKeyPairValid =
    isKeyPairValid (msg->encryptionKey, client->privateKey);
// printf ("\n> hook\n%i\n\n", verificationHook_isKeyPairValid);
// VERIFICATION HOOK END
  if (!client->privateKey)
    return;
  if (msg->isEncrypted == 1
      && 0 == strcmp (msg->encryptionKey, client->privateKey))
    {
      msg->encryptionKey = NULL;
      msg->isEncrypted = 0;
    }
}
